<html>
<head>
<title>AV-MA-01</title>
<!--Move Array Physical Drive Choices Update Page-->
<style>
<!#master.css>
<!#adv.css>
</style>
<meta http-equiv="Content-Type" content="text/html; charset=<!=/ACU-XE/CharSet=Message>iso-8859-1<!/CharSet>"/>
</head>
<!#common.htm>
<script type="text/javascript" src="ACUTools.js"></script>
<script type="text/javascript" src="Advanced.js"></script>
<script type="text/javascript" src="checkbox.js"></script>
<script type="text/javascript">
numChoices = 0;
var disableNext = false;

option = new Array();
<!.Request=PDRIVE_REPLACE_CHOICES>
<!.Request=FOCUS>
<!.Request=TAG>
<!.Request=CONTROLLER_DUAL_DOMAIN_CAPABLE>

// Global variable used for selector name
var g_sSelectorName = "DRIVE_TYPE";
var initialSelectionDriveMap = new Array();

for (var i=0; i<numChoices; ++i )
{
   // If the item is selected, add it to the map
   initialSelectionDriveMap[i] = option[i].checked;
}
function HandlePhysicalDriveSelectionChange(index)
{
   NCFormReferenceArrayToggleItem(index);
   // document.arrayPhysicalDrivesForm.submit();
}

function HandleSelectAll(isSelectAll)
{
   var selectObj = document.getElementById(g_sSelectorName);
   for (var i=0; i<numChoices; ++i )
   {
      if (option[i].itemType == selectObj.value)
      {
         // If any item is un-checked, check it (and notify the server)
         if ( !option[i].checked && isSelectAll)
         {
            NCFormReferenceArrayToggleItem(i);
         }
         else if ( option[i].checked && !isSelectAll)
         {
            NCFormReferenceArrayToggleItem(i);
         }
      }
   }
   // document.arrayPhysicalDrivesForm.submit();
}

function ValidateAVMA01()
{ 
   if ( !disableNext )
   {
      var isOkToSubmit = true;
      var numChecked = 0;
      var hasChanged = false;
      for( i = 0; i < numChoices; ++i )
      {
         if ( option[i].checked )
         {
            ++numChecked;
            if ( !initialSelectionDriveMap[i] )
            {
               hasChanged = true;
            }
         }
      }
      if ( numChecked != numDrivesRequired )
      {      
         var parmArray = new Array();
         parmArray[0] = numDrivesRequired;
         var note = new Object();
         note.text = LoadString("PX_TAG_MOVE_ARRAY_INCORRECT_NUMBER_OF_DRIVES");
         note.parmLength = parmArray.length;
         note.parm = parmArray;
         ACUAlert(InsertParmsInString(note));
         isOkToSubmit = false;
      }
      if ( isOkToSubmit && !hasChanged )
      {
         // The user has not made any changes
         ACUAlert(LoadString("PX_TAG_MOVE_ARRAY_NO_CHANGES_MADE"));
         isOkToSubmit = false;
      }
      if ( isOkToSubmit )
      {
         disableNext = true;
         SetTaskData("updateDataFormComplete", false);
         document.updateMigrationForm.submit();
         WaitForDataReadyAndSubmit();
      }
   }
   return false;
}

function WaitForDataReadyAndSubmit()
{
   dataComplete = GetTaskData("updateDataFormComplete");
   if ( !dataComplete )
   {
      setTimeout("WaitForDataReadyAndSubmit();", 500);
   }
   else
   {
      Submit();
   }
}

function Submit()
{
   document.nextNoMigration.submit();
   disableNext = false;
   return false;
}

function WritePhysicalDriveCommands()
{
   for ( var i=0; i<numChoices; ++i )
   {
      physicalDriveCommand = offcommand;
      if (option[i].checked)
      {
         physicalDriveCommand = command;
      }
      WriteCommand( physicalDriveCommand, option[i].id );
   }
}

InitAdvKeyboard();

//------------------------------------------------------------------------------
// Name: showSelDrives()
// Desc: This function shows a specified type of physical drives in a checkbox
//       table. It makes non-specified drives invisible. The type of drive
//       specified is determined by inspecting an HTML select object. This
//       function is typically called when the user changes drive type. All
//       checkboxes are intitialized to unchecked everytime this function is
//       called.
//
//       The following objects are global and used by showSelDrives()
//
//             DRIVE_TYPE - HTML select object whos value is the user-specified
//                        drive type.
//             option   - an array containing all available physical drives
//             option[i].focusTag + "_ROW" - a row in the checkbox table that
//                                           can be visible or invisible, this
//                                           is actually a span id.
// Parameters:      initPhase (if true, do not uncheck boxes or update server)
// Return Value:    none
// Pre-conditions:  Global objects must exist and be initialized
// Post-conditions: none
//                                                                     mm29Oct03
//------------------------------------------------------------------------------

function showSelDrives(initPhase)
{
   var selectObj = document.getElementById(g_sSelectorName);
   var nCount = 0;
   
   if (!initPhase)
   {
      if(document.displayForm && document.displayForm.CheckBoxAll)
      {
         document.displayForm.CheckBoxAll.checked = false;
      }
   }

   for(var i=0; i<numChoices; ++i )
   {      
      if ( !initPhase && option[i].checked )
      {
         // If any item is checked, uncheck it (and notify the server)
         HandlePhysicalDriveSelectionChange(i);
      }
      var driveObj = document.getElementById(option[i].focusTag + "_ROW");
      if(driveObj && selectObj)
      {
         if(option[i].itemType == selectObj.value)
         {
            driveObj.style.display = "block";
            if (!initPhase)
            {
               eval("document.displayForm.CheckBox" + i + ".checked = false;");  // unchecked
            }
            ++nCount;
         }
         else
         {
            driveObj.style.display = "none";
         }
      }
   }

   // Show the select all checkbox only if we have more than 1 checkboxes
   var checkAllObj = document.getElementById("CheckBoxAll_ROW");
   if(checkAllObj)
   {
      if(nCount > 1)
      {
         checkAllObj.style.display = "block";
      }
      else
      {
         checkAllObj.style.display = "none";
      }

      // Display Correct select all image
      if(selectObj.value == GetData("SAS_PHYSICAL_DRIVE"))
      {
         document.getElementById("CheckBoxAllImg").src = "./Images/GnSASDriveAll.gif";
      }
      //else if (selectObj.value == GetData("SATA_PHYSICAL_DRIVE"))
      else if (selectObj.value == GetData("SATA_LOGICAL_DRIVE"))
      {
         document.getElementById("CheckBoxAllImg").src = "./Images/GnSATADriveAll.gif";
      }
      else
      {
         document.getElementById("CheckBoxAllImg").src = "./Images/GnACUPDriveAll.gif";
      }
   }
}

</script>
<body id="BODY" class="normalbody" onfocus="advFocus();" onblur="advBlur();" onload="advLoad();" oncontextmenu="return DisableRightClick();">
<TABLE width=100%  border=0 cellpadding=0 cellspacing=0 align=center >
   <TR width=100% id=configtableHead>
      <TD id=configtableHead align=left valign=top><IMG src="./Images/top_left_trans.gif"></TD>
      <TD id=configtableHead align=center nowrap>
         <script>
            WriteString("PX_TAG_MOVE_ARRAY");
         </script></TD>      
      <TD id=configtableHead align=right valign=top><IMG src="./Images/top_right_trans.gif"></TD>
   </TR>
   <TR width=100%>
      <TD id=configtable colspan=3>
         <script>
         DisplayStandardNote("PX_TAG_MOVE_ARRAY_NOTE");
         DisplayStandardNote("PX_TAG_NOTE_MOVE_ARRAY_MIXED_CAPACITY");
         if (controllerDualDomainCapable)
         {
            DisplayStandardNote("PX_TAG_NOTE_MOVE_ARRAY_MIXED_1P_2P_SAS_DRIVES");
         }
         DisplayStandardNote("PX_TAG_NOTE_MOVE_ARRAY_WILL_DROP_SPARES");
         </script>
      </TD>
   </TR>
<!--      
   <TR id=configtable width=100%>
      <TD id=configtable colspan=3>
      <BR>
      <table width=100% border=0 cellpadding=0 cellspacing=0 class=normal>
         <tr id=advTableHeader width=100% align=center>
            <td id=configtable width=10 height=25>&nbsp;</td>
            <td width=100% id=advTableHeader align=center>
            <script>
            document.write(LoadString("PX_TAG_AV_PDRIVE_SELECT_DRIVE_TYPE"));
            </script></td>
            <td id=configtable width=10 height=25>&nbsp;</td>
         </tr>
-->         
         <!-- Here is where we put the array type selector widget in -->
<!--         
         <TR width=100% align=center>
            <td width=10 height=25>&nbsp;</td>
            <td width=100% align=center>
            <br />
            <script>
               var selectTable = new Array();
               var stringTable = new Array();
               var defaultDriveTypeIndex = 0;
               for(var i=0; i<option.length; ++i)
               {
                  var sTemp = stringTable.toString();
                  if( sTemp.indexOf(option[i].typeDesc) == -1)
                  {
                     selectTable[option[i].itemType] = option[i].itemType;
                     stringTable[option[i].itemType] = option[i].typeDesc;
                     if (option[i].checked)
                     {
                        defaultDriveTypeIndex = selectTable.length - 1;
                     }                     
                  }
               }
               DisplaySelectTable( "", g_sSelectorName, selectTable, stringTable, "", "" );
               if (selectTable.length > 1)
               {
                  document.getElementById(g_sSelectorName).selectedIndex = defaultDriveTypeIndex;
               }
               document.getElementById(g_sSelectorName).onchange = showSelDrives;
            </script></td>            
            <td width=10 height=25>&nbsp;</td>
         </TR>
      </TABLE><br /></td>
   </TR>
-->         
   <FORM autocomplete="off" name="displayForm">
   <TR width=100%>
      <TD id=configtable colspan=3>
         <script>
         DisplayStandardCheckBoxTable(LoadString("PX_TAG_AV_PDRIVE_SELECT_FOR_MOVE"), option, numChoices, "HandlePhysicalDriveSelectionChange");         
//         DisplayStandardCheckBoxTable(LoadString("PX_TAG_AV_PDRIVE_SELECT_FOR_MOVE"), option, numChoices, "HandlePhysicalDriveSelectionChange", "HandleSelectAll", "./Images/GnACUPDriveAll.gif");
//         showSelDrives(true);
         </script></TD>         
   </TR>
   </FORM>         
   <TR id=configtable>
      <TD id=configtable colspan=3>
         <script>
            DisplayStandardOKCancelButtonNavWithValidation("AV-Config.htm", "AV-Config.htm", "ValidateAVMA01()" );
         </script>
      </TD>
   </TR>
</TABLE>
<FORM name="updateMigrationForm" method="post" target="AVMA01BFrame" action="AV-MA-01B.htm">
      <script>
      insertUser();
      insertFocus();
      insertSource();
      </script>
   </FORM>
<FORM name="nextNoMigration" method="post" target="config" action="AV-Config.htm">
   <script>
      WritePhysicalDriveCommands();
      WriteCommand( "IS_ARRAY_MOVE_FLAG", "DEFAULT");
      WriteCommand( "END_ADD_PDRIVE", "DEFAULT");
      insertUser();
      insertFocus();
      insertSource();
      WriteCommand( "END_TRANSACTION", "DEFAULT" );
      </script>
   </FORM>
<script>
      NCFormReferenceArrayInit( document.nextNoMigration );
</script>
<FORM name="cancel">
      <script>
      insertUser();
      insertFocus();
      insertSource();
      WriteCommand("UNDO_TRANSACTION","DEFAULT");
      </script>
   </FORM>
</BODY>
<script SRC="advkey.js"></script>
</HTML>