function RemoteProcedureCall(url, method, mode)
{
  this.url = null;
  if (url)
    this.url = url;
  this.variables = [];
  this.method = "GET";
  if (method)
    this.method = method;
  this.callback;
  this.addVariable = function addVariable(name, value)
  {
    if (value == undefined || value == null)
      value = "";
    this.variables.push([encodeQueryComponent(name), encodeQueryComponent(value)]);
  }

  this.removeVariable = function removeVariable(name)
  {
    var foundVariable = false;
    for (var i=0; i<this.variables.length && foundVariable == false; i++)
    {
      if (this.variables[i][0] == name)
      {
        this.variables.splice(i,1);
        foundVariable = true;
      }
    }
  }

  this.clearVariables = function clearVariables()
  {
    this.variables = [];
  }

  this.getQueryString = function getQueryString()
  {
    var flatArray = [];
    for (i=0; i<this.variables.length; i++)
      flatArray.push(this.variables[i].join("="));
    return flatArray.join("&");
  }

  this.send = function send()
  {
    switch(this.mode)
    {
    case ("iframe"):
      this.sendPseudoRequest();
      break;
    default:
      this.sendRequest();
    }
  }

  this.sendRequest = function()
  {
    var query = this.getQueryString();
    var callback = this.statechange;
    var request = this.request;
    var control = this;
    if (this.method == "POST")
    {
      this.request.open(this.method, this.url, true);
      this.request.onreadystatechange = function()
      {
        callback(request, control);
      }
      this.request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      this.request.send(query);
    }
    else
    {
      this.request.open(this.method, this.url+"?"+query, true);
      this.request.onreadystatechange = function()
      {
        callback(request, control);
      }
      this.request.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
      this.request.send(null);
    }
  }

  this.sendPseudoRequest = function sendPseudoRequest()
  {
    this.request.onload = "";
    this.request.src = "";
    var callback = this.pseudoload;
    var request = this.request;
    var control = this;
    if (this.method == "GET")
    {
      var query = this.getQueryString();
      var url = this.url+"?"+query;
      this.request.onload = function()
      {
        callback(request, control);
      }
      this.request.src = url;
    }
    else
    {
      this.request.onload = function()
      {
        var form = request.contentWindow.document.getElementById("ui_blankForm");
        for (var i=0; i<control.variables.length; i++)
        {
          var input = form.appendChild(document.createElement("input"));
          input.type = "hidden";
          input.name = control.variables[i][0];
          input.value = control.variables[i][1];
        }
        form.method = "post";
        form.action = control.url;
        request.onload = function()
        {
          callback(request, control);
        }
        form.submit();
      }
      this.request.src = "ui_blankForm.html";
    }
  }

  this.statechange = function statechange(request, control)
  {
    if (request.readyState == 4)
    {
      if (request.status == 200)
        control.callback(request.responseText)
    }
  }

  this.pseudoload = function pseudoload(request, control)
  {
    control.callback(request.contentWindow.document.body.innerHTML);
  }

  // INIT
  this.request = null;
  if (mode == "XMLHttpRequest" || (mode == undefined && this.request == null))
  {
    try
    {
      this.request = new XMLHttpRequest();
      this.mode = "XMLHttpRequest";
    }
    catch(e){}
  }
  if (mode == "ActiveX" || (mode == undefined && this.request == null))
  {
    try
    {
      this.request = new ActiveXObject("Msxml2.XMLHTTP");
      this.mode = "ActiveX";
      this.submode = "Msxml2.XMLHTTP";
    }
    catch(e)
    {
      try
      {
        this.request = new ActiveXObject("Microsoft.XMLHTTP");
        this.mode = "ActiveX";
        this.submode = "Microsoft.XMLHTTP";
      }
      catch(e){}
    }
  }
  if (mode == "iframe" || (mode == undefined && this.request == null))
  {
    try
    {
      this.request = document.createElement("iframe");
      this.request.style.height = "0";
      this.request.style.width = "0";
      this.request.style.padding = "0";
      this.request.style.height = "0";
      this.request.style.border = "none";
      this.mode = "iframe";
      document.body.appendChild(this.request);
    }
    catch(e){}
  }
}

function encodeQueryComponent(string)
{
  var URIencode = encodeURIComponent(string);
  return URIencode.replace(/%20/g, "+");
}
