<?php
include "fefunctions.php";
include "iocommand.php";
start_session();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["page"] = "errorlog.php";
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <TITLE>HP Insight Diagnostics</TITLE>
</head>
<body>
<?php
  // get slots specified by diagconfig.xml
  $dom = LoadXmlDocument($_SESSION["diagsDirectory"] ."diagconfig.xml");
  $diagConfig = xpath_new_context($dom->document_element());
  $obj = xpath_eval($diagConfig, "/factory/ErrorScreenSlots");
  if (count($obj->nodeset)) // did it find the tag?
  {
    $num_slots = $obj->nodeset[0]->get_attribute("slots");    
  }
  $slotArray = array();
  $slotArray = array_fill(0,$num_slots,"empty");
  $errorCaption = array();
  $errorCaption = array_fill(0,$num_slots,"empty");
  $errorCode = array();
  $errorCode = array_fill(0,$num_slots,"empty");
  $testCaption = array();
  $testCaption = array_fill(0,$num_slots,"empty");

  // get error log
  $errorLogError = "";
  $errorLogString = "";
  $getErrorLogString = sprintf("<getErrorLog language='%s'/>", $language);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $getErrorLogString, $errorLogString, $errorLogError);
  $errordoc = @new DomDocument($errorLogString);
  $errorRoot = @$errordoc->document_element();
  $errorLogXpath = @xpath_new_context($errordoc->document_element());

  // get test log
  $testLogError = "";
  $testLogString = "";
  $getTestLogString = sprintf("<getTestLog language='%s'/>", $language);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $getTestLogString, $testLogString, $testLogError);
  $testdoc = @new DomDocument($testLogString);
  $testLogXpath = @xpath_new_context($testdoc->document_element());
  $testLogRecords = @xpath_eval($testLogXpath, "/testLogRecord");
  $num_testLogRecords = count($testLogRecords->nodeset); // should only be 1 - replace with find first match if possible
  //echo htmlentities($testdoc->html_dump_mem());

  // search the test log to see which slots were tested
  for ($i=0; $i < $num_testLogRecords; $i++)
  {
    $testLogRecord = $testLogRecords->nodeset[$i];
    $device = $testLogRecord->get_attribute("device");
    $test = $testLogRecord->get_attribute("test");
    $caption = $testLogRecord->get_attribute("testCaption");
    
    $slot_pos = strstr($caption, "Slot");

    if ($slot_pos)
    {
      $st = substr($slot_pos, 5);
      $chars = preg_split('//', $st, -1, PREG_SPLIT_NO_EMPTY);
      $num_chars = count($chars);
      
      for ($j=0; $j < $num_chars; $j++)
      {
        if (!is_numeric($chars[$j]))
          break;
      }
      $slot = substr($slot_pos, 5, $j); // finally got the slot from the caption
      
      
	    $errorLogRecords = @xpath_eval($errorLogXpath, "/errorLogRecord[@device='".$device."' and @test='".$test."']");
	    $num_errorLogRecords = count($errorLogRecords->nodeset); // should only be 1 - replace with find first match if such a thing exists in DOM
      
      if ($num_errorLogRecords)
      {
        $testCaption[$slot] = $caption;
        $slotArray[$slot] = "failed";
        $errXpath = xpath_new_context($errorLogRecords->nodeset[0]);
        $errs = xpath_eval($errXpath, "/error");
        $errorCaption[$slot] = $errs->nodeset[0]->get_attribute("caption");
        $errorCode[$slot] = $errs->nodeset[0]->get_attribute("errorCode");
      }
      else if ($slotArray[$slot] != "failed")
        $slotArray[$slot] = "passed";      
      
    }
  }
  $width = 100/$num_slots;
  printf("<table border=3 cellspacing=10 width=100%% height=95%%><tr><td align=center colspan=%d style=\"height:5%%;\"><h1>Final test status</h1></td></tr><tr>", $num_slots);
  for ($k=1; $k < count($slotArray); $k++)
  {
    if ($slotArray[$k] == "failed")
    {
      printf("<td bgcolor=red align=center width=%d%%><center><b>%s<br>%s<br>%s</td>", $width, $testCaption[$k], $errorCaption[$k], $errorCode[$k]);
    }
    else if ($slotArray[$k] == "passed")
      printf("<td bgcolor=green align=center width=%d%%><center><b>Slot %s<br>PASSED</td>", $width, $k);
    else
      printf("<td align=center width=%d%%><center><b>Slot %s<br>EMPTY</td>", $width, $k);
  }

?>
</tr></table>
<center><input type=button onclick="window.close();" value="OK - Close Window"></center>
</body>
</html>

